/* PONG - (C) 1994 Threshold Software */

#include <stdio.h>    /* Header files */
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

int x,y, /* ball */
    x1,y1, /* player 2's paddle */
    x2,y2, /* player 1's paddle */
    dx,dy, /* ball offset */
    sc1,sc2, /* scores */
    length,
    range,
    mx,my,mbt, /* mouse */
    stat,h,control;

long d,
     t;

char a,instruct,play,skill;

union REGS regs;

int mstatus() /* checks mouse status */
{
  int mstat;

  regs.x.ax = 0;
  int86(0x33, &regs, &regs);
  mstat = regs.x.ax;
  return mstat;
}


void mshow() /* show mouse cursor */
{
  regs.h.al = 1;
  int86(0x33, &regs, &regs);
}

void mpos() /* position mouse cursor */
{
  regs.x.ax = 3;
  mbt = regs.x.bx;
  mx = regs.x.cx;
  my = regs.x.dx;
  int86(0x33, &regs, &regs);
}

void mput() /* get mouse coordinates */
{
  regs.x.ax = 4;
  regs.x.cx = 10;
  regs.x.dx = 96;
  int86(0x33, &regs, &regs);
}

void init() /* initialize ball variables */
{
  x=6;y=3;
  dx=2;dy=1;
}

void up1() /* move player 2's paddle up one space */
{
  for (t=0; t<=length; t++)
    {
      gotoxy(x1,y1+t);
      cprintf(" ");
    }
  y1-=1;
  if (y1<=3)
    y1=3;
}

void down1() /* move player 2's paddle down one space */
{
  for (t=0; t<=length; t++)
    {
      gotoxy(x1,y1+t);
      cprintf(" ");
    }
  y1+=1;
  /* check skill level and paddle boundary */
  if (skill == '1' && y1>=19)
    y1=19;
  if (skill == '2' && y1>=20)
    y1=20;
  if (skill == '3' && y1>=21)
    y1=21;
}

void up2() /* move player 1's paddle up one space */
{
  for (t=0; t<=length; t++)
    {
      gotoxy(x2,y2+t);
      cprintf(" ");
    }

  y2 -= 1;
  if (y2<=3)
    y2=3;
}

void down2() /* move player 1's paddle down one space */
{
  for (t=0; t<=length; t++)
    {
      gotoxy(x2,y2+t);
      cprintf(" ");
    }

  y2 += 1;
  /* check skill level and paddle boundary */

  if (skill == '1' && y2>=19)
    y2=19;
  if (skill == '2' && y2>=20)
    y2=20;
  if (skill == '3' && y2>=21)
    y2=21;
}


void thanks()
{
  printf("Thank you for playing PONG.\n");
}


void instructions() /* print instructions */
{
  textcolor(15);
  clrscr(); /* clear the screen */
  printf("PONG\n");
  printf("By Alan Bruzzi\n\n");
  printf("PONG is a simple game of ping-pong\n");
  printf("on the computer.  The object of the\n");
  printf("game is to score 15 points before your\n");
  printf("opponent does.  Player 1 is on the left\n");
  printf("side, while player 2 is on the right.\n\n");
  printf("NOTE:  This game requires a mouse!\n\n");
  printf("CONTROLS\n\n");
  printf("Player 1:  Move mouse up or down\n");
  printf("           Button 1 = Increase speed\n");
  printf("           Button 2 = Decrease speed\n");
  printf("Player 2:  8 = Up, 2 = Down\n\n");
  printf("p = pause\n");
  printf("q = quit\n\n");
  printf("Press any key to begin: ");
  a = getch(); /* get a keypress */
}


void drawpaddles() /* draw the paddles on the screen */
{
  gotoxy(x1,y1);
  cprintf("");

  gotoxy(x2,y2);
  cprintf("");

  for (t=1; t<=length-1; t++)
    {
      gotoxy(x1,y1+t);
      textcolor(13);
      cprintf(""); /* print computer's paddle */
      gotoxy(x2,y2+t);
      textcolor(2);
      cprintf(""); /* print player's paddle */
    }

  gotoxy(x1,y1+length);
  cprintf("");

  gotoxy(x2,y2+length);
  cprintf("");
}


void drawball(long f)
{
  gotoxy(x,y);
  textcolor(15);
  putch(254); /* print ball */
  delay(f);

  gotoxy(x,y); /* erase ball */
  putch(32);
}


void game(long dlay) /* game loop */
{
  int times = 0;

  textbackground(1); /* set background to blue */
  clrscr(); /* clear the screen */

  do {

   if (dlay <= 5)
     dlay = 5;

   if (dlay >= 50)
     dlay = 50;

   if (times == 10) /* if ball bounces off 10 times, decrease delay
		       by 5 and reset "times" */
     {
       dlay -= 5;
       times = 0;
     }

   /* print scores */

   gotoxy(1,1);
   textcolor(13);
   cprintf("PONG Scores  = ");

   /* print logo */

   gotoxy(1,25);
   textcolor(15);
   cprintf("Threshold Software");


   gotoxy(17,1); /* position cursor */
   textcolor(2);
   cprintf("%d",sc1);

   /* print borders */

   gotoxy(1,2);
   for (t=1; t<=40; t++)
     cprintf("");

   gotoxy(1,24);
   for (t=1; t<=40; t++)
     cprintf("");

   textcolor(13);
   gotoxy(25,1);
   cprintf("%d",sc2);

   for (t=-1; t<=5; t++)
    {

      if (x==x1-1 && y==y1+t)
	{
	  dx=-dx;
	  times++;
	  sound(680); /* beep */
	  for (t=1; t<=5000; t++);
	  nosound(); /* turn sound off */
	}

      if (x==x2+2 && y==y2+t)
	{
	  dx=-dx;
	  times++;
	  sound(780); /* beep */
	  for (t=1; t<=5000; t++);
	  nosound(); /* turn sound off */
	}

    }

  for (t=3; t<=23; t++)
    {
      gotoxy(21,t);
      textcolor(15);
      cprintf(""); /* print court in center of screen */
    }

  drawpaddles(); /* call drawpaddles routine */
  drawball(dlay);

  range = random(6);

  if (play == '1' && y > y1 + range)
    down1();

  if (play == '1' && y < y1 + 1)
    up1();

  x=x+dx; /* increment x */


  switch (x) { /* check x coordinate of ball */

    case 0:  {
	       sc2+=1;
	       cprintf("\07"); /* beep */
	       init();
	       times = 0;
	       dlay = d;
	       break;
	     }

    case 40: {
	       sc1+=1;
	       cprintf("\07"); /* beep */
	       init();
	       times = 0;
	       dlay = d;
	       break;
	     }
    }

  y=y+dy; /* increment y */

  switch (y) {

    case 3:  {
	       dy=-dy;
	       sound(440); /* beep */
	       for (t=1; t<=5000; t++);
	       nosound();
	       break;
	     }

    case 23: {
	       dy=-dy;
	       sound(580); /* beep */
	       for (t=1; t<=5000; t++);
	       nosound();
	       break;
	     }
    }


  mpos(); /* get mouse input */

  switch (mbt) {

    case 1:  dlay -= 5; /* left button */
	     break;

    case 2:  dlay += 5; /* right button */
	     break;

  }


  if (my == 0)
    up2();

  if (my == 192)
    down2();

  if (kbhit())
    a = getch();

  switch (a) {

    case 'a':  {
		 up2();
		 a = ' ';
		 break;
	       }

    case 'z':  {
		 down2();
		 a = ' ';
		 break;
	       }


    case '8':  {
		 up1();
		 a = ' ';
		 break;
	       }

    case '2':  {
		 down1();
		 a = ' ';
		 break;
	       }

    case 'q':  {
		 textmode(C80);
		 thanks();
		 regs.x.ax = 0x4c00;
		 int86(0x21, &regs, &regs);
		 break;
	       }

    case 'p':  {
		 a = getch();
		 a = ' ';
		 break;
	       }

  }

  gotoxy(17,1);
  textcolor(2);
  cprintf("%d",sc1);

  gotoxy(25,1);
  textcolor(13);
  cprintf("%d",sc2);

  textcolor(15);

  drawpaddles();

 } while (sc1 < 15 && sc2 < 15);


 /* game over */
 gotoxy(17,12);
 cprintf("GAME OVER");
 sound(440); /* play short tune */
 sleep(1);
 sound(400);
 sleep(1);
 sound(360);
 sleep(1);
 nosound();
 sleep(2); /* wait two seconds */

}

void main()
{

 stat = mstatus(); /* check for a mouse */

 if (stat == 0)
   {
     printf("This game requires a Microsoft mouse!\n");
     exit(-1);
   }

 randomize();

 do {
  textbackground(0); /* make background black */
  textcolor(7);
  clrscr(); /* clears the screen */
  textmode(C40); /* puts screen in 40 columns */

  regs.h.ah = 0x01;
  regs.h.ch = 0x00;
  regs.h.cl = 0x0d;
  int86(0x10, &regs, &regs); /* Turn cursor on */

  d=0;
  x1=40;
  y1=20;
  x2=1;
  y2=4;
  length=4;
  range=4;

  drawpaddles();

  gotoxy(10,3);
  textcolor(15);
  cprintf(""); /* print a white ball */

  gotoxy(1,1);

  /* print title screen */

  textcolor(14);
  cprintf("\n\n\n\n\n\n\n\n\n\n\                 P O N G");
  printf("\n\n\n\n       (C) 1994 Threshold Software");
  printf("                 1972 Atari Corp.");
  printf("\n\nBall speed? (Enter a zero to quit): ");
  scanf("%d",&d);

  if (d == 0)
    {
      textmode(C80);
      thanks();
      regs.x.ax = 0x4c00;
      int86(0x21, &regs, &regs);
    }

  printf("1 or 2 players? (1/2): ");
  regs.h.ah = 1;
  int86(0x21, &regs, &regs);
  play = regs.h.al;

  printf("\nSkill level? (1/2/3): ");
  regs.h.ah = 1;
  int86(0x21, &regs, &regs);
  skill = regs.h.al;

  switch (skill) { /* check skill level */

    case '1':  {
	       range = 4;
	       length = 4;
	       break;
	     }

    case '2':  {
	       length = 3;
	       range = 3;
	       break;
	     }

    case '3':  {
	       length = 2;
	       range = 2;
	     }

  }


  printf("\nDo you want instructions? (y/n): ");
  regs.h.ah = 1;
  int86(0x21, &regs, &regs);
  instruct = regs.h.al;

  if (instruct == 'y')
    instructions(); /* print instructions */

  clrscr(); /* clears the screen */
  init();

  x1=39; /* coordinates for */
  y1=12; /* computer's paddle */

  x2=2;  /* coordindates for */
  y2=12; /* player's paddle */

  sc1=0; /* reset scores */
  sc2=0;


  regs.h.ch = 0x20;
  regs.h.ah = 0x01;
  int86(0x10, &regs, &regs); /* Turn cursor off */

  mput();

  game(d); /* go to game loop */


 } while (d!=0); /* repeat until ball speed = 0 */


}
